﻿class ChessPiece {
	var type:String, color:String, column:Number, row:Number, clip:MovieClip, tileWidth:Number, lastMove:Number;
	var firstMove:Boolean = true;
	var tileThreats:Array;
	var currentTile:Tile;
	var alive:Boolean = true;
	var id:String;
	var boardReverse:Boolean = false;
	function ChessPiece(theType:String, col:String) {
		//constructor
		color = col;
		setType(theType);
		setID();
		tileThreats = new Array();
	}
	function setReverse(newVal:Boolean) {
		boardReverse = newVal;
	}
	function setID(tmp_id:Number) {
		id = tmp_id.toString();
	}
	function getID():String {
		return id;
	}
	function removeClip() {
		clip.removeMovieClip();
	}
	function getAlive():Boolean {
		return alive;
	}
	function setAlive(tmp_alive:Boolean) {
		alive = tmp_alive;
	}
	function addTileThreat(theTile:Tile) {
		if (theTile != undefined) {
			tileThreats.push(theTile);
		}
	}
	function addTile(theTile:Tile) {
		currentTile = theTile;
	}
	function getTile():Tile {
		return currentTile;
	}
	function clearTileThreats() {
		for (var i = 0; i<tileThreats.length; ++i) {
			var tmp_tile:Tile = tileThreats[i];
			tmp_tile.removeThreatPiece(this);
		}
		tileThreats = new Array();
	}
	function getTileThreats():Array {
		return tileThreats;
	}
	function setClip(theClip:MovieClip) {
		clip = theClip;
		clip._name = "piece"+getID();
		displayPiece();
	}
	function displayPiece() {
		clip.gotoAndStop(color+" "+type);
	}
	function changeType(newType:String) {
		setType(newType);
		displayPiece();
	}
	function getClip() {
		return clip;
	}
	function setLastMove(num:Number) {
		lastMove = num;
		firstMove = false;
	}
	function getLastMove():Number {
		return lastMove;
	}
	function setPosition(x:Number, y:Number) {
		column = x;
		row = y;
		var tmp_column:Number = column;
		var tmp_row:Number = row;
		if (boardReverse) {
			tmp_column = 7-tmp_column;
			tmp_row = 7-tmp_row;
		}
		clip._x = tileWidth*tmp_column+tileWidth/2;
		clip._y = tileWidth*tmp_row+tileWidth/2;
	}
	function get isFirstMove():Boolean {
		return firstMove;
	}
	function set isFirstMove(val:Boolean) {
		firstMove = val;
	}
	function setTileWidth(theWidth:Number) {
		tileWidth = theWidth;
	}
	function getType():String {
		return type;
	}
	function getColor():String {
		return color;
	}
	function setType(theType:String) {
		type = theType;
	}
}
