﻿function pluginInit(hash) {
	//This method is called when the room starts
	trace("----Plug-in Initialized----");
	trace("Zone name: "+getZoneName());
	trace("Room name: "+getRoomName());
}
function pluginRequest(hash) {
	var caller = hash.get("ExecutingUserName");
	var method = hash.get("Method");
	if (method == "DoSomething") {
		doSomeRoomVariableStuff();
	} else if (method == "TestMessage") {
		testMessage(caller);
	} else if (method == "InspectServer") {
		inspectServer(caller);
	}
}
function inspectServer(caller) {
	//Just showing how to get the list of zones, and get the rooms per zone
	var zones = getAllZones();
	trace("--Tracing all Zones and Rooms--");
	for (var i=0;i<zones.length;++i) {
		var zone = zones[i];
		trace("Zone="+zone.Name);
		//
		var rooms = getRoomsInZone(zone.Name);
		for (var j=0;j<rooms.length;++j) {
			var room = rooms[j];
			trace("   Room="+room.Name+", hidden="+room.hidden);
			var users = getUsersInRoom(zone.Name, room.Name);
			for (var k=0;k<users.length;++k) {
				var user = users[k];
				trace("       User="+user.Name);
			}
		}
	}
}
function testMessage(caller) {
	//Showing how to send a message to all rooms in a zone
	var variables = new Object();
	variables.firstName = "Jobe";
	variables.lastName = "Makar";
	var action = "TestZoneMessage";
	//Send the message to a specific zone
	server.sendMessage("zone", "Chat Area", action, variables);
	//Send the message to the whole server
	var action = "TestServerMessage";
	server.sendMessage("server", action, variables);
}

function pluginDestroy() {
	//called when the plug-in is being removed
	trace("---Plug-in removed--");
}
function traceRoomVariables() {
	var roomVars = getRoomVariables();
	trace("---Room Variables--");
	for (var i = 0; i<roomVars.length; ++i) {
		var roomVar = roomVars[i];
		var varName = roomVar.name
		var value = roomVar.value
		var locked = roomVar.locked
		var persistent = roomVar.persistent;
		trace(varName+"="+value+"   locked="+locked+", persistent="+persistent);
	}
}
function doSomeRoomVariableStuff() {
	//Create a room variable
	var name = "secreteWord";
	var value = "kazam";
	var locked = false;
	trace("...creating a room variable");
	createRoomVariable(name, value, locked);
	//
	traceRoomVariables();
	//
	var value = "ala kazam";
	trace("...updating a room variable");
	updateRoomVariable(name, value, locked);
	//
	traceRoomVariables();
	//
	trace("...deleting a room variable");
	deleteRoomVariable(name);
	//
	traceRoomVariables();
	//
}
function traceUserVariables(user) {
	//Grab the object that contains the user's user variables
	var userVars = getUserVariables(user);
	trace("----User Variables for "+user+" ----");
	for (var i = 0; i<userVars.length; ++i) {
		var userVar = userVars[i];
		var varName = userVar.name;
		var varValue = userVar.value;
		trace(varName+"="+varValue);
	}
}
function pluginUserEnter(user) {
	trace("User entered: "+user);
	//Create a user variable on the new user. Its just a random age.
	trace("...creating a user variable.");
	createUserVariable(user, "age", random(100));
	createUserVariable(user, "favorite_color", "blue");
	traceUserVariables(user);
	//Update user variable
	trace("...updating the user variable");
	updateUserVariable(user, "age", 5);
	traceUserVariables(user);
	//Delete it
	trace("...deleting the user variable");
	deleteUserVariable(user, "age");
	traceUserVariables(user);
}
function pluginUserExit(user) {
	trace("User left: "+user);
}
function returnToUser(value, caller) {
	var variables = new Object();
	variables.result = value;
	var action = "CalculationResult";
	server.sendMessage("private", [caller], action, variables);
}
